package uprrp.tania;

import android.os.AsyncTask;
import android.util.Log;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLEncoder;

import javax.net.ssl.HttpsURLConnection;

public class SendActivateExperienceToServer extends AsyncTask<String, String, String> {

    private final String TAG = "SendActivateExperience";
    private final URLEventListener myCallBack;
    private URLEventListener myCallback;

    public SendActivateExperienceToServer(URLEventListener callback) {
        this.myCallBack = callback;
    }

    @Override
    protected String doInBackground(String... strings) {

        String experienceRegistrationJSON = strings[0]; // array will only ever contain a single element
        String jsonActivateExperience = "";

        // Encode data
        try {
            jsonActivateExperience = URLEncoder.encode("data", "UTF-8") + "=" + URLEncoder.encode(experienceRegistrationJSON, "UTF-8");
        } catch (UnsupportedEncodingException e) {
            Log.e(TAG, "Couldn't encode the following JSON: " + experienceRegistrationJSON);
            e.printStackTrace();
            return null;
        }

        // Send data
        try {

            // Send POST data request
            URL url = new URL("https://tania.uprrp.edu/inscripcionExperiencia.php"); // TODO: extract URL into @string/activateExperienceURL
            HttpsURLConnection conn = (HttpsURLConnection) url.openConnection();
            conn.setDoOutput(true);
            OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
            wr.write(jsonActivateExperience);
            wr.flush();

            // Get the server response
            BufferedReader serverReader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            StringBuilder serverResponse = new StringBuilder();

            String line = "";
            while(line != null) {
                serverResponse.append(line);
                line = serverReader.readLine();
            }

            String response = serverResponse.toString();
            if(response.startsWith("Success")) {
                return response;
            } else {
                return null;
            }


        } catch(Exception e) {
            Log.e("Couldn't communicate with server while activating experience!", e.getMessage());
        }

        return null;

    }

    @Override
    protected void onPostExecute(String response) {

        if(this.myCallBack == null) {
            this.myCallBack.onFailure(new Exception("Callback wasn't initialized first!"));
            return;
        }

        if(response == null) {
            this.myCallback.onFailure(new Exception("Error occurred during transaction!"));
            return;
        }

        Log.d("ACTIVATE EXPERIENCE RESPONSE", "The server's response is: " + response);
        this.myCallBack.onSuccess();

    }

}
